package nc.ui.gl.vouchercard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import nc.bs.logging.Logger;
import nc.pub.gl.voucher.parallel.ParallelAccounts;
import nc.ui.bd.BDGLOrgBookAccessor;
import nc.ui.gl.cashflowcase.CashFlowGather;
import nc.ui.gl.cashflowcase.CfTableCellFormatter;
import nc.ui.gl.common.CompConsts;
import nc.ui.gl.datacache.AccsubjDataCache;
import nc.ui.gl.datacache.CashFlowDataCache;
import nc.ui.gl.datacache.CurrencyDataCache;
import nc.ui.gl.datacache.GLParaDataCache;
import nc.ui.gl.vouchertools.VoucherDataCenter;
import nc.ui.glcom.numbertool.GlNumberFormat;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIComboBox;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UILabel;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIPopupMenu;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.UITextField;
import nc.ui.pub.beans.ValueChangedEvent;
import nc.ui.pub.beans.ValueChangedListener;
import nc.ui.pub.beans.constenum.DefaultConstEnum;
import nc.ui.pub.bill.BillCellEditor;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.ui.pub.bill.BillEditListener2;
import nc.ui.pub.bill.BillItem;
import nc.ui.pub.bill.BillModel;
import nc.ui.pub.bill.BillScrollPane;
import nc.ui.pub.bill.BillTableSelectionChangeListener;
import nc.ui.pub.bill.BillTableSelectionEvent;
import nc.vo.bd.b02.AccsubjVO;
import nc.vo.bd.b20.CurrtypeVO;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.gl.accbook.OrientConst;
import nc.vo.gl.cashflowcase.CFPubProxy;
import nc.vo.gl.cashflowcase.CashflowForVoucherVO;
import nc.vo.gl.cashflowcase.CashflowVO;
import nc.vo.gl.cashflowcase.CashflowcaseVO;
import nc.vo.gl.cashflowcase.CfVOAdapter;
import nc.vo.gl.cashflowcase.SubrelationVO;
import nc.vo.gl.cashflowcase.analyze.CashFlowSortTool;
import nc.vo.gl.cashflowcase.analyze.CashflowAnalyzeExecutor;
import nc.vo.gl.cashflowcase.analyze.CfAnalyzeEnvVO;
import nc.vo.gl.cashflowcase.analyze.IAnalyzeAction;
import nc.vo.gl.cashflowcase.analyze.ICfAnalyzeContainer;
import nc.vo.gl.pubvoucher.DetailVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.gl.sysparam.SystemParamConfig;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;

public class CFAnalyzeJitUI extends UIDialog implements ValueChangedListener, BillEditListener, BillEditListener2, PropertyChangeListener, BillTableSelectionChangeListener, ICfAnalyzeContainer, IAnalyzeAction {

   public static final int EDIT_MODE_MUTABLE = 1;
   public static final int EDIT_MODE_IMMUTEABLE = 0;
   private int editMode;
   private int currentselectedrow = -1;
   private static final long serialVersionUID = 1L;
   private UIPanel contentPanel = null;
   private UIPanel ivjUIPanelMain = null;
   private UIPanel northPanel = null;
   private BillScrollPane bodyTable = null;
   private BillModel bodyTableModel = null;
   private UIPanel ivjUIPanel1 = null;
   CFAnalyzeJitUI.IvjEventHandler ivjEventHandler = new CFAnalyzeJitUI.IvjEventHandler();
   private UIButton btnLoad = null;
   private UIButton btnAnalyze = null;
   private UIButton btnBatchOp = null;
   private UIButton btnAddLine = null;
   private UIButton btnDelLine = null;
   private UIComboBox analyzeType = null;
   private UIButton btnCancel = null;
   private UIButton btnOK = null;
   private UIRefPane mainCfItemPane = null;
   private UIRefPane subCfItemPane = null;
   private UILabel labelAmount = null;
   private UIComboBox currTypeBox = null;
   HashMap detailSubjMap = null;
   HashMap detailBackupMap = null;
   CashflowVO[] cashflows;
   Vector unanalyzedDetails = null;
   Vector analyzedDetails = null;
   SubrelationVO[] subRelation;
   private DetailVO[] details;
   private VoucherVO voucherVO;
   private Integer selectedIndex;
   Map subjmap = new HashMap();
   private String m_pk_glorgbook = null;
   private String m_pk_corp = null;
   private UFDate date;
   HashMap currencyMap = new HashMap();
   CFAnalyzeJitUI.ToolTipRenderer tooltiprenderer = new CFAnalyzeJitUI.ToolTipRenderer();
   private BillCellEditor moneyEditor;
   private BillCellEditor moneyMainEditor;
   private CashFlowSortTool sortTool;


   private BillCellEditor getMoneyEditor() {
      if(this.moneyEditor == null) {
         UITextField field = new UITextField();
         field.setTextType("TextDbl");
         this.moneyEditor = new BillCellEditor(field);
      }

      return this.moneyEditor;
   }

   private BillCellEditor getMoneyMainEditor() {
      if(this.moneyMainEditor == null) {
         UITextField field = new UITextField();
         field.setTextType("TextDbl");
         int pre = 2;

         try {
            if(this.getLocalCurrPk() != null) {
               pre = CurrencyDataCache.getInstance().getCurrtypeBypk(this.getLocalCurrPk()).getCurrdigit().intValue();
            }
         } catch (Exception var4) {
            MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), var4.getMessage());
         }

         field.setNumPoint(pre);
         this.moneyMainEditor = new BillCellEditor(field);
      }

      return this.moneyMainEditor;
   }

   private void connEtoC1() {
      try {
         if(this.getBodyTable().getTable().isEditing()) {
            this.getBodyTable().getTable().editingStopped(new ChangeEvent(this));
         }

         CfVOAdapter.cashflowname_map.clear();
         super.closeCancel();
      } catch (Throwable var2) {
         ;
      }

   }

   private boolean isCashVoucher() {
      Collection collection = this.subjmap.values();
      Iterator iter = collection.iterator();

      AccsubjVO subj;
      do {
         if(!iter.hasNext()) {
            return false;
         }

         subj = (AccsubjVO)iter.next();
      } while(subj == null || subj.getCashbankflag() == null || subj.getCashbankflag().intValue() <= 0);

      return true;
   }

   private void connEtoC2() {
      try {
         if(this.editMode == 1) {
            if(this.getBodyTable().getTable().isEditing()) {
               this.getBodyTable().getTable().editingStopped(new ChangeEvent(this));
            }

            CashflowForVoucherVO[] ivjExc = this.getCurrentBodyVOs();
            if(ivjExc == null) {
               super.closeOK();
            }

            int j;
            CashflowForVoucherVO[] amount;
            if(!this.isCashVoucher() && this.voucherVO.getVoucherkind().intValue() != 223) {
               CashflowForVoucherVO[] map = ivjExc;
               j = ivjExc.length;

               for(int matchStr = 0; matchStr < j; ++matchStr) {
                  CashflowForVoucherVO array = map[matchStr];
                  if(array.getPk_cashflow_main() != null) {
                     MessageDialog.showHintDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl57", "UPP2002gl57-000004"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-002785"));
                     amount = ivjExc;
                     int subamount = ivjExc.length;

                     for(int recordVo = 0; recordVo < subamount; ++recordVo) {
                        CashflowForVoucherVO vo1 = amount[recordVo];
                        vo1.setPk_cashflow_main((String)null);
                        vo1.setMainCfItem((String)null);
                     }

                     this.formatTable(ivjExc);
                     return;
                  }
               }
            }

            this.detailSubjMap.clear();

            int var14;
            for(var14 = 0; var14 < this.details.length; ++var14) {
               this.detailSubjMap.put(this.details[var14].getDetailindex(), this.details[var14].getPk_accsubj());
            }

            for(var14 = 0; var14 < ivjExc.length; ++var14) {
               if((ivjExc[var14].getPk_cashflow_main() != null || ivjExc[var14].getPk_cashflow_ass() != null) && ivjExc[var14].getM_pk_currtype() == null) {
                  MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000303") + (var14 + 1) + NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000362"));
                  return;
               }
            }

            HashMap var15 = new HashMap();

            for(j = 0; j < this.getDetails().length; ++j) {
               String var16 = "";
               var15.clear();
               if(this.getDetails()[j].getPk_detail() == null) {
                  var16 = this.getDetails()[j].getPk_voucher() + "-" + this.getDetails()[j].getDetailindex();
               } else {
                  var16 = this.getDetails()[j].getPk_detail();
               }

               for(int var17 = 0; var17 < ivjExc.length; ++var17) {
                  if(var16.equals(ivjExc[var17].getM_pk_detail()) && this.getDetails()[j].getCreditamount().equals(ivjExc[var17].getCreditAmount()) && (ivjExc[var17].getPk_cashflow_main() != null && !ivjExc[var17].getPk_cashflow_main().trim().equals("") || ivjExc[var17].getPk_cashflow_ass() != null && !ivjExc[var17].getPk_cashflow_ass().trim().equals(""))) {
                     if(ivjExc[var17].getLocalAmount() == null || ivjExc[var17].getLocalAmount().equals(new UFDouble(0))) {
                        MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000363"));
                        return;
                     }

                     amount = null;
                     CashflowcaseVO var19;
                     String var21;
                     CashflowcaseVO var23;
                     if(ivjExc[var17].getPk_cashflow_main() != null && !ivjExc[var17].getPk_cashflow_main().trim().equals("")) {
                        var21 = ivjExc[var17].getPk_cashflow_main() + "_" + ivjExc[var17].getM_pk_currtype();
                        if(var15.get(var21) != null) {
                           var23 = (CashflowcaseVO)var15.get(var21);
                           var23.setMoney(var23.getMoney().add(ivjExc[var17].getOccAmount()));
                           var23.setMoneymain(var23.getMoneymain().add(ivjExc[var17].getLocalAmount()));
                        } else {
                           var19 = new CashflowcaseVO();
                           var19.setAccsubjFlag(Integer.valueOf(0));
                           var19.setCashflowcode(CfVOAdapter.getCashflow(ivjExc[var17].getPk_cashflow_main()).getCfitemcode());
                           var19.setCashflowFlag(Integer.valueOf(0));
                           var19.setCashflowName(CfVOAdapter.getCashflow(ivjExc[var17].getPk_cashflow_main()).getCfitemname());
                           var19.setFlag(Integer.valueOf(ivjExc[var17].getOccAmount().doubleValue() < 0.0D?-1:1));
                           var19.setPk_cashflow(ivjExc[var17].getPk_cashflow_main());
                           var19.setPk_corp(ClientEnvironment.getInstance().getCorporation().getPk_corp());
                           var19.setPk_detail(ivjExc[var17].getM_pk_detail());
                           var19.setMoney(ivjExc[var17].getOccAmount());
                           var19.setMoneymain(ivjExc[var17].getLocalAmount());
                           var19.setMoneyass(ivjExc[var17].getFracAmount());
                           var19.setPk_glorgbook(this.getPK_GLOrgBook());
                           var19.setM_pk_currtype(ivjExc[var17].getM_pk_currtype());
                           var15.put(var21, var19);
                        }
                     }

                     if(ivjExc[var17].getPk_cashflow_ass() != null && !ivjExc[var17].getPk_cashflow_ass().trim().equals("")) {
                        var21 = ivjExc[var17].getPk_cashflow_ass() + "_" + ivjExc[var17].getM_pk_currtype();
                        if(var15.get(var21) != null) {
                           var23 = (CashflowcaseVO)var15.get(var21);
                           var23.setMoney(var23.getMoney().add(ivjExc[var17].getOccAmount()));
                           var23.setMoneymain(var23.getMoneymain().add(ivjExc[var17].getLocalAmount()));
                        } else {
                           var19 = new CashflowcaseVO();
                           var19.setPk_cashflow(ivjExc[var17].getPk_cashflow_ass());
                           var19.setAccsubjFlag(Integer.valueOf(0));
                           var19.setCashflowcode(CfVOAdapter.getCashflow(ivjExc[var17].getPk_cashflow_ass()).getCfitemcode());
                           var19.setCashflowFlag(Integer.valueOf(0));
                           var19.setCashflowName(CfVOAdapter.getCashflow(ivjExc[var17].getPk_cashflow_ass()).getCfitemname());
                           var19.setFlag(Integer.valueOf(ivjExc[var17].getOccAmount().doubleValue() < 0.0D?-1:1));
                           var19.setPk_corp(ClientEnvironment.getInstance().getCorporation().getPk_corp());
                           var19.setPk_detail(ivjExc[var17].getM_pk_detail());
                           var19.setMoney(ivjExc[var17].getOccAmount());
                           var19.setMoneymain(ivjExc[var17].getLocalAmount());
                           var19.setMoneyass((UFDouble)null);
                           var19.setPk_glorgbook(this.getPK_GLOrgBook());
                           var19.setM_pk_currtype(ivjExc[var17].getM_pk_currtype());
                           var15.put(var21, var19);
                        }
                     }
                  }
               }

               if(var15.size() > 0) {
                  CashflowcaseVO[] var18 = new CashflowcaseVO[var15.values().size()];
                  var15.values().toArray(var18);
                  UFDouble var20 = new UFDouble(0);
                  UFDouble var22 = new UFDouble(0);
                  CashflowcaseVO[] var24 = var18;
                  int var25 = var18.length;

                  for(int var10 = 0; var10 < var25; ++var10) {
                     CashflowcaseVO vo = var24[var10];
                     String itemflag = this.getCfItemFlagByPk(this.getPK_Corp(), vo.getPk_cashflow());
                     if(itemflag != null && !itemflag.equals("0")) {
                        if(itemflag.equals("1")) {
                           var22 = var22.add(vo.getMoneymain());
                        }
                     } else {
                        var20 = var20.add(vo.getMoneymain());
                     }
                  }

                  this.getDetails()[j].setCashFlow(var18);
               } else {
                  this.getDetails()[j].setCashFlow((CashflowcaseVO[])null);
               }
            }
         }

         super.closeOK();
      } catch (Throwable var13) {
         var13.printStackTrace();
      }

   }

   private void connEtoC3() {
      try {
         CashflowForVoucherVO[] ivjExc = this.getCurrentBodyVOs();
         int currentEndRowe = this.getBodyTable().getTableModel().getRowCount();
         int increment = 0;
         Iterator var4 = this.unanalyzedDetails.iterator();

         while(var4.hasNext()) {
            CashflowForVoucherVO unanalyzedDetail = (CashflowForVoucherVO)var4.next();
            if(((AccsubjVO)this.subjmap.get(unanalyzedDetail.getM_pk_accsubj())).getChecktype().intValue() != ParallelAccounts.SUBJ_HS_YS.intValue()) {
               boolean shouldAdd = true;
               CashflowForVoucherVO[] var7 = ivjExc;
               int var8 = ivjExc.length;

               for(int var9 = 0; var9 < var8; ++var9) {
                  CashflowForVoucherVO onevo = var7[var9];
                  if(onevo.getM_pk_detail().equals(unanalyzedDetail.getM_pk_detail())) {
                     shouldAdd = false;
                     break;
                  }
               }

               if(shouldAdd) {
                  this.getBodyTable().getTableModel().addLine();
                  this.getBodyTable().getTableModel().setBodyRowVO(this.formatVO(unanalyzedDetail), currentEndRowe + increment);
                  ++increment;
                  this.setDispalyAlias();
               }
            }
         }

         this.getBodyTable().getTableModel().sortByColumn(0, true);
         this.getBodyTable().getTableModel().updateValue();
      } catch (Throwable var11) {
         var11.printStackTrace();
      }

   }

   private Vector getUnCfDetail() {
      Vector voucherData = new Vector();
      if(this.unanalyzedDetails != null) {
         voucherData.addAll(this.unanalyzedDetails);
      }

      if(this.analyzedDetails != null) {
         voucherData.addAll(this.analyzedDetails);
      }

      return voucherData;
   }

   private void connEtoC4() {
      try {
         this.analyzeVoucher();
      } catch (Throwable var2) {
         Logger.error(var2);
      }

   }

   private void connEtoC5() {
      try {
         if(this.getBodyTable().getTable().getRowCount() < 1 || this.getBodyTable().getTable().getSelectedRow() < 0) {
            MessageDialog.showWarningDlg(this, NCLangRes.getInstance().getStrByID("200235", "UPP200235-000044"), NCLangRes.getInstance().getStrByID("200235", "UPP200235-000081"));
            return;
         }

         int[] ivjExc = this.getBodyTable().getTable().getSelectedRows();
         if(ivjExc.length > 0) {
            CashFlowGather gatherUI = new CashFlowGather(this);
            if(gatherUI.showModal() == 1) {
               try {
                  String e = gatherUI.getUIRefPane1().getRefPK();
                  double bl = (new UFDouble(gatherUI.getUITextField1().getText())).div(100.0D).doubleValue();
                  CashflowForVoucherVO[] voucherVO = this.getCurrentBodyVOs();

                  int i;
                  for(i = 0; i < ivjExc.length; ++i) {
                     CashflowVO pk_glorgbook;
                     if(CfVOAdapter.cashflow_map.get(e) == null) {
                        pk_glorgbook = CfVOAdapter.getCashflow(e);
                        if(pk_glorgbook.getItemflag() != null && !pk_glorgbook.getItemflag().equals("0")) {
                           voucherVO[ivjExc[i]].setPk_cashflow_ass(e);
                           voucherVO[ivjExc[i]].setSubCFItem(pk_glorgbook.getCfitemname());
                        } else {
                           voucherVO[ivjExc[i]].setPk_cashflow_main(e);
                           voucherVO[ivjExc[i]].setMainCfItem(pk_glorgbook.getCfitemname());
                        }

                        CfVOAdapter.cashflow_map.put(e, pk_glorgbook);
                     } else {
                        pk_glorgbook = (CashflowVO)CfVOAdapter.cashflow_map.get(e);
                        if(pk_glorgbook.getItemflag() != null && !pk_glorgbook.getItemflag().equals("0")) {
                           voucherVO[ivjExc[i]].setPk_cashflow_ass(e);
                           voucherVO[ivjExc[i]].setSubCFItem(pk_glorgbook.getCfitemname());
                        } else {
                           voucherVO[ivjExc[i]].setPk_cashflow_main(e);
                           voucherVO[ivjExc[i]].setMainCfItem(pk_glorgbook.getCfitemname());
                        }
                     }

                     String var13 = this.getPK_GLOrgBook();
                     String pk_currtype = ((CurrtypeVO)gatherUI.getGlComboBox().getSelectedUserData()).getPk_currtype();
                     voucherVO[ivjExc[i]].setM_pk_currtype(pk_currtype);
                     UFDouble amount = voucherVO[ivjExc[i]].getLocalDebitAmount() != null && voucherVO[ivjExc[i]].getLocalDebitAmount().doubleValue() != 0.0D?voucherVO[ivjExc[i]].getLocalDebitAmount():voucherVO[ivjExc[i]].getLocalCreditAmount();
                     voucherVO[ivjExc[i]].setLocalAmount(this.getAmount(amount.multiply(bl), var13, pk_currtype));
                     voucherVO[ivjExc[i]].setOccAmount(this.getAmount(this.getCurAdjustedValue(voucherVO[ivjExc[i]], voucherVO[ivjExc[i]].getLocalAmount(), pk_currtype, 1), var13, pk_currtype));
                  }

                  for(i = 0; i < voucherVO.length; ++i) {
                     this.adjustDirection(voucherVO[i]);
                  }

                  this.formatTable(voucherVO);
               } catch (Throwable var11) {
                  if(Logger.isErrorEnabled()) {
                     Logger.error(var11);
                  }

                  return;
               }
            }
         }
      } catch (Throwable var12) {
         var12.printStackTrace();
      }

   }

   private void connEtoC6() {
      try {
         if(this.getBodyTable().getTable().getSelectedRows().length > 0) {
            int[] ivjExc = this.getBodyTable().getTable().getSelectedRows();
            CashflowForVoucherVO[] currentVOs = this.getCurrentBodyVOs();
            ArrayList list = new ArrayList();
            ArrayList deletelist = new ArrayList();
            if(ivjExc == null || ivjExc.length == 0 || currentVOs == null || currentVOs.length == 0) {
               return;
            }

            this.getBodyTable().getTableModel().delLine(ivjExc);
            CashflowForVoucherVO[] pklist = currentVOs;
            int deletepklist = currentVOs.length;

            int deleterecord;
            CashflowForVoucherVO adddeleterecord;
            for(deleterecord = 0; deleterecord < deletepklist; ++deleterecord) {
               adddeleterecord = pklist[deleterecord];
               list.add(adddeleterecord);
            }

            int[] var16 = ivjExc;
            deletepklist = ivjExc.length;

            for(deleterecord = 0; deleterecord < deletepklist; ++deleterecord) {
               int var20 = var16[deleterecord];
               deletelist.add(currentVOs[var20]);
               list.remove(currentVOs[var20]);
            }

            ArrayList var17 = new ArrayList();
            ArrayList var18 = new ArrayList();
            Iterator var19 = list.iterator();

            while(var19.hasNext()) {
               adddeleterecord = (CashflowForVoucherVO)var19.next();
               var17.add(adddeleterecord.getM_pk_detail());
            }

            var19 = deletelist.iterator();

            while(var19.hasNext()) {
               adddeleterecord = (CashflowForVoucherVO)var19.next();
               var18.add(adddeleterecord.getM_pk_detail());
            }

            var18.removeAll(var17);
            Vector var21 = new Vector();
            Vector var22 = new Vector();
            HashSet set = new HashSet();
            Iterator var10 = this.analyzedDetails.iterator();

            while(var10.hasNext()) {
               CashflowForVoucherVO vo = (CashflowForVoucherVO)var10.next();
               if(var18.contains(vo.getM_pk_detail())) {
                  vo.setMainCfItem((String)null);
                  vo.setPk_cashflow_main((String)null);
                  vo.setPk_cashflow_main((String)null);
                  vo.setSubCFItem((String)null);
                  UFDouble amount = this.details[vo.getM_detailno().intValue() - 1].getCreditamount();
                  UFDouble amount1 = this.details[vo.getM_detailno().intValue() - 1].getDebitamount();
                  boolean isDebit = amount == null || amount.doubleValue() == 0.0D;
                  vo.setOccAmount(isDebit?amount1:amount);
                  vo.setLocalAmount(isDebit?this.details[vo.getM_detailno().intValue() - 1].getLocaldebitamount():this.details[vo.getM_detailno().intValue() - 1].getLocalcreditamount());
                  if(!set.contains(vo.getM_pk_detail())) {
                     var22.add(vo);
                     set.add(vo.getM_pk_detail());
                  }

                  var21.add(vo);
               }
            }

            this.analyzedDetails.removeAll(var21);
            this.unanalyzedDetails.addAll(var22);
         }
      } catch (Throwable var15) {
         var15.printStackTrace();
      }

   }

   private void connEtoC7() {
      try {
         int ivjExc = this.getBodyTable().getTable().getSelectedRow();
         int rowcount = this.getBodyTable().getTable().getRowCount();
         int selectedrowcount = this.getBodyTable().getTable().getSelectedRowCount();
         if(ivjExc != -1 && ivjExc != rowcount - 1) {
            this.getBodyTable().getTableModel().insertRow(ivjExc + selectedrowcount);
         } else {
            this.getBodyTable().getTableModel().addLine();
         }
      } catch (Throwable var4) {
         Logger.error(var4);
      }

   }

   public CFAnalyzeJitUI(Container parent, HashMap detailSubjMap, int editMode) {
      super(parent);
      this.detailSubjMap = detailSubjMap;
      this.editMode = editMode;
      this.initialize();
   }

   public CFAnalyzeJitUI(Container parent, HashMap detailSubjMap, int editMode, VoucherVO voucher) {
      super(parent);
      this.detailSubjMap = detailSubjMap;
      this.editMode = editMode;
      this.voucherVO = voucher;
      this.initialize();
   }

   private void initialize() {
      try {
         this.setName("VoucherCfAnalyze");
         this.setDefaultCloseOperation(2);
         this.setSize(UIManager.getInt("DialogType1.width"), UIManager.getInt("DialogType1.height"));
         this.setTitle(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000300"));
         this.setContentPane(this.getUIDialogContentPane());
         this.initializeConnections();
         if(this.editMode == 1) {
            this.getBodyTable().addRowSelectionChangeListener(this);
            this.getBodyTable().getTable().requestFocus();
         } else {
            this.getBodyTable().getTable().setEnabled(false);
         }
      } catch (Throwable var2) {
         ;
      }

   }

   private void initializeConnections() {
      if(this.editMode == 1) {
         this.getBtnCancel().setEnabled(true);
         this.getBtnOK().setEnabled(true);
         this.getBtnLoad().setEnabled(true);
         this.getBtnAnalyze().setEnabled(true);
         this.getBtnBatchOp().setEnabled(true);
         this.getBtnAddLine().setEnabled(true);
         this.getBtnDelLine().setEnabled(true);
      } else {
         this.getBtnCancel().setEnabled(true);
         this.getBtnOK().setEnabled(true);
         this.getBtnLoad().setEnabled(false);
         this.getBtnAnalyze().setEnabled(false);
         this.getBtnBatchOp().setEnabled(false);
         this.getBtnAddLine().setEnabled(false);
         this.getBtnDelLine().setEnabled(false);
      }

      this.getBtnCancel().addActionListener(this.ivjEventHandler);
      this.getBtnOK().addActionListener(this.ivjEventHandler);
      this.getBtnLoad().addActionListener(this.ivjEventHandler);
      this.getBtnAnalyze().addActionListener(this.ivjEventHandler);
      this.getBtnBatchOp().addActionListener(this.ivjEventHandler);
      this.getBtnAddLine().addActionListener(this.ivjEventHandler);
      this.getBtnDelLine().addActionListener(this.ivjEventHandler);
   }

   private JPanel getUIDialogContentPane() {
      if(this.contentPanel == null) {
         try {
            this.contentPanel = new UIPanel();
            this.contentPanel.setName("UIDialogContentPane");
            this.contentPanel.setLayout(new BorderLayout());
            this.getUIDialogContentPane().add(this.getNorthPanel(), "North");
            this.getUIDialogContentPane().add(this.getUIPanelMain(), "Center");
         } catch (Throwable var2) {
            ;
         }
      }

      return this.contentPanel;
   }

   private UIComboBox getCurrTypeBox() {
      if(this.currTypeBox == null) {
         this.currTypeBox = new UIComboBox();
         CurrtypeVO[] currTypes = null;

         try {
            currTypes = CurrencyDataCache.getInstance().getCurrtypeBypkCorp(this.getPK_Corp());
         } catch (Exception var6) {
            Logger.error(var6);
            var6.printStackTrace();
         }

         if(currTypes != null) {
            CurrtypeVO[] e = currTypes;
            int var3 = currTypes.length;

            for(int var4 = 0; var4 < var3; ++var4) {
               CurrtypeVO vo = e[var4];
               this.currTypeBox.addItem(vo.getCurrtypecode());
               this.currencyMap.put(vo.getCurrtypecode(), vo.getPk_currtype());
            }
         }
      }

      return this.currTypeBox;
   }

   private UIComboBox getAnalyzeType() {
      if(this.analyzeType == null) {
         this.analyzeType = new UIComboBox();
         this.analyzeType.addItem("");
         this.analyzeType.addItem(NCLangRes4VoTransl.getNCLangRes().getStrByID("200235", "UPP200235-000078"));
         this.analyzeType.addItem(NCLangRes4VoTransl.getNCLangRes().getStrByID("200235", "UPP200235-000009"));
         this.analyzeType.addItem(NCLangRes4VoTransl.getNCLangRes().getStrByID("200235", "UPP200235-000079"));
         this.analyzeType.addItem(NCLangRes4VoTransl.getNCLangRes().getStrByID("200235", "UPP200235-000080"));
         this.analyzeType.setSelectedIndex(0);
      }

      return this.analyzeType;
   }

   private UIPanel getNorthPanel() {
      if(this.northPanel == null) {
         this.northPanel = new UIPanel();
         this.northPanel.setLayout(new BorderLayout(UIManager.getInt("DialogTopContent.hEmptyBorder"), UIManager.getInt("DialogTopContent.vEmptyBorder")));
         this.northPanel.setPreferredSize(new Dimension(10, UIManager.getInt("DialogTopContent.vEmptyBorder") * 2 + CompConsts.getTextHeight()));
         if(this.voucherVO.getVoucherkind().intValue() != 223) {
            this.northPanel.add(this.getUILabelAmount(), "West");
         }

         Box box = Box.createHorizontalBox();
         if(this.voucherVO.getVoucherkind().intValue() != 223) {
            box.add(new UILabel(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000364")));
            box.add(this.getAnalyzeType());
            box.add(new UILabel(" "));
            this.northPanel.add(box, "East");
         }
      }

      return this.northPanel;
   }

   private UILabel getUILabelAmount() {
      if(this.labelAmount == null) {
         this.labelAmount = new UILabel();
         this.labelAmount.setText(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000365"));
      }

      return this.labelAmount;
   }

   private UIPanel getUIPanelMain() {
      if(this.ivjUIPanelMain == null) {
         try {
            this.ivjUIPanelMain = new UIPanel();
            this.ivjUIPanelMain.setName("UIPanelMain");
            this.ivjUIPanelMain.setLayout(new BorderLayout());
            this.getUIPanelMain().add(this.getUIPanel1(), "South");
            this.getUIPanelMain().add(this.getBodyTable(), "Center");
         } catch (Throwable var2) {
            ;
         }
      }

      return this.ivjUIPanelMain;
   }

   private UIPanel getUIPanel1() {
      if(this.ivjUIPanel1 == null) {
         try {
            this.ivjUIPanel1 = new UIPanel();
            this.ivjUIPanel1.setName("UIPanel1");
            this.ivjUIPanel1.setPreferredSize(CompConsts.getDlgSouthDimension());
            this.ivjUIPanel1.setLayout(CompConsts.getDlgSouthBtnLayout());
            this.ivjUIPanel1.setBorder(CompConsts.getDlgSouthBorder());
            if(this.voucherVO.getVoucherkind().intValue() == 223) {
               this.getUIPanel1().add(this.getBtnLoad(), this.getBtnLoad().getName());
               this.getUIPanel1().add(this.getBtnBatchOp(), this.getBtnBatchOp().getName());
               this.getUIPanel1().add(this.getBtnOK(), this.getBtnOK().getName());
               this.getUIPanel1().add(this.getBtnCancel(), this.getBtnCancel().getName());
               this.getUIPanel1().add(this.getBtnAddLine(), this.getBtnAddLine().getName());
               this.getUIPanel1().add(this.getBtnDelLine(), this.getBtnDelLine().getName());
            } else {
               this.getUIPanel1().add(this.getBtnLoad(), this.getBtnLoad().getName());
               this.getUIPanel1().add(this.getBtnAnalyze(), this.getBtnAnalyze().getName());
               this.getUIPanel1().add(this.getBtnBatchOp(), this.getBtnBatchOp().getName());
               this.getUIPanel1().add(this.getBtnAddLine(), this.getBtnAddLine().getName());
               this.getUIPanel1().add(this.getBtnDelLine(), this.getBtnDelLine().getName());
               this.getUIPanel1().add(this.getBtnOK(), this.getBtnOK().getName());
               this.getUIPanel1().add(this.getBtnCancel(), this.getBtnCancel().getName());
            }
         } catch (Throwable var2) {
            ;
         }
      }

      return this.ivjUIPanel1;
   }

   public void valueChanged(ValueChangedEvent event) {
      int row = this.currentselectedrow;
      CashflowForVoucherVO[] vos = this.getCurrentBodyVOs();
      if(event.getSource() == this.getMainCfItemPane()) {
         vos[row].setPk_cashflow_main(this.getMainCfItemPane().getRefPK());
      }

      if(event.getSource() == this.getSubCfItemPane()) {
         vos[row].setPk_cashflow_ass(this.getSubCfItemPane().getRefPK());
      }

      this.formatLine(vos[row], row);
   }

   public void afterEdit(BillEditEvent event) {
      int row = event.getRow();
      if(event.getKey().equals("m_detailno")) {
         BillModel vo = this.getBodyTable().getTableModel();
         Integer pk_currtype = (Integer)vo.getValueAt(row, 0);
         if(pk_currtype.intValue() > this.details.length) {
            MessageDialog.showWarningDlg(this, NCLangRes.getInstance().getStrByID("200235", "UPP200235-000044"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000366"));
            this.getBodyTable().getTableModel().delLine(new int[]{row});
            return;
         }

         if(!SystemParamConfig.getInstance().isCfsubjPermitted()) {
            AccsubjVO e = (AccsubjVO)this.subjmap.get(this.details[pk_currtype.intValue() - 1].getPk_accsubj());
            if(e.getCashbankflag() != null && e.getCashbankflag().intValue() > 0) {
               this.getBodyTable().getTableModel().setValueAt((Object)null, row, 0);
               MessageDialog.showWarningDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000293"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000367"));
               return;
            }

            if(e.getChecktype().intValue() == ParallelAccounts.SUBJ_HS_YS.intValue()) {
               this.getBodyTable().getTableModel().setValueAt((Object)null, row, 0);
               MessageDialog.showWarningDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000293"), "预算类科目不能增加现金流量信息!");
               return;
            }
         }

         try {
            CashflowForVoucherVO var20 = CfVOAdapter.constructUnanalyzedVO(this.details[pk_currtype.intValue() - 1]);
            UFDouble leftRawamount = new UFDouble(0);
            UFDouble leftmainamount = new UFDouble(0);
            CashflowForVoucherVO[] currentcfs = this.getCurrentBodyVOs();
            if(currentcfs != null) {
               CashflowForVoucherVO[] var9 = currentcfs;
               int var10 = currentcfs.length;

               for(int var11 = 0; var11 < var10; ++var11) {
                  CashflowForVoucherVO unvo = var9[var11];
                  if(unvo.getM_pk_detail() != null && unvo.getM_pk_detail().equals(var20.getM_pk_detail())) {
                     leftRawamount = leftRawamount.add(unvo.getOccAmount());
                     leftmainamount = leftmainamount.add(unvo.getLocalAmount());
                  }
               }
            }

            var20.setOccAmount(var20.getOccAmount() != null?var20.getOccAmount().sub(leftRawamount):UFDouble.ZERO_DBL);
            var20.setLocalAmount(var20.getLocalAmount() != null?var20.getLocalAmount().sub(leftmainamount):UFDouble.ZERO_DBL);
            this.formatLine(var20, row);
         } catch (Exception var16) {
            if(Logger.isErrorEnabled()) {
               Logger.error("转换vo出错", var16);
               var16.printStackTrace();
            }
         }
      }

      CashflowForVoucherVO var17;
      if(event.getKey().equals("mainCfItem")) {
         var17 = (CashflowForVoucherVO)this.getBodyTable().getTableModel().getBodyValueRowVO(row, "nc.vo.gl.cashflowcase.CashflowForVoucherVO");
         this.adjustDirection(var17);
         if(var17.getMainCfItem() == null) {
            var17.setOccAmount(var17.getCreditAmount() != null && var17.getCreditAmount().doubleValue() != 0.0D?var17.getCreditAmount():var17.getDebitAmount());
            var17.setLocalAmount(var17.getLocalCreditAmount() != null && var17.getLocalCreditAmount().doubleValue() != 0.0D?var17.getLocalCreditAmount():var17.getLocalDebitAmount());
         }

         this.getBodyTable().getTableModel().setBodyRowVO(var17, row);
         this.formatLine(var17, row);
      }

      UFDouble var18;
      if(event.getKey().equals("occAmount")) {
         try {
            var17 = this.getCurrentRowVO();
            var18 = this.getAmount(var17.getOccAmount(), this.getPK_GLOrgBook(), var17.getM_pk_currtype());
            var17.setOccAmount(var18);
            if(223 == this.voucherVO.getVoucherkind().intValue()) {
               var17.setLocalAmount(var18);
            } else {
               UFDouble var21 = this.getAmount(this.getCurAdjustedValue(var17, var17.getOccAmount(), var17.getM_pk_currtype(), 0), this.getPK_GLOrgBook(), var17.getM_pk_currtype());
               var17.setLocalAmount(var21);
            }

            this.getBodyTable().getTableModel().setBodyRowVO(var17, row);
            this.setDispalyAlias();
         } catch (Exception var15) {
            Logger.error(var15);
         }
      }

      if(event.getKey().equals("localAmount")) {
         try {
            var17 = this.getCurrentRowVO();
            if(this.getLocalCurrPk() != null && this.getLocalCurrPk().equals(this.getCurrentRowVO().getM_pk_currtype())) {
               if(223 == this.voucherVO.getVoucherkind().intValue()) {
                  var17.setOccAmount(this.getAmount(var17.getLocalAmount(), this.getPK_GLOrgBook(), this.getLocalCurrPk()));
               } else {
                  var17.setOccAmount(this.getAmount(this.getCurAdjustedValue(var17, var17.getLocalAmount(), var17.getM_pk_currtype(), 1), this.getPK_GLOrgBook(), var17.getM_pk_currtype()));
               }
            }

            var18 = this.getAmount(var17.getLocalAmount(), this.getPK_GLOrgBook(), this.getLocalCurrPk());
            var17.setLocalAmount(var18);
            this.getBodyTable().getTableModel().setBodyRowVO(var17, row);
            this.setDispalyAlias();
         } catch (Exception var14) {
            Logger.error(var14);
         }
      }

      if(event.getKey().equals("currtype")) {
         var17 = this.getCurrentRowVO();
         String var19 = (String)this.currencyMap.get((String)this.getCurrTypeBox().getSelectdItemValue());
         if(var19 != null && var17 != null) {
            var17.setM_pk_currtype(var19);

            try {
               if(var17.getLocalAmount() != null) {
                  var17.setLocalAmount(this.getAmount(this.getCurAdjustedValue(var17, var17.getOccAmount(), var17.getM_pk_currtype(), 0), this.getPK_GLOrgBook(), var17.getM_pk_currtype()));
               }

               this.getBodyTable().getTableModel().setBodyRowVO(var17, this.getBodyTable().getTable().getSelectedRow());
               this.setDispalyAlias();
            } catch (Exception var13) {
               Logger.error(var13);
            }
         }
      }

   }

   private String getLocalCurrPk() {
      return GLParaDataCache.getInstance().PkLocalCurr(this.getPK_GLOrgBook());
   }

   public void bodyRowChange(BillEditEvent e) {
   }

   public void propertyChange(PropertyChangeEvent evt) {
   }

   public BillScrollPane getBodyTable() {
      if(this.bodyTable == null) {
         this.bodyTable = new BillScrollPane();
         this.bodyTable.setTableModel(this.getBodyTableModel());
         this.bodyTable.setAutoscrolls(true);
         this.bodyTable.addEditListener(this);
         this.bodyTable.addEditListener2(this);
         UIPopupMenu menu = this.bodyTable.getTable().getHeaderPopupMenu();
         Component component = menu.getComponent(3);
         menu.remove(component);
         TableColumn columnMoneymainNumber = this.getBodyTable().getTable().getColumnModel().getColumn(8);
         TableColumn columnMoneyNumber = this.getBodyTable().getTable().getColumnModel().getColumn(7);
         columnMoneyNumber.setCellEditor(this.getMoneyEditor());
         columnMoneymainNumber.setCellEditor(this.getMoneyMainEditor());
         CfTableCellFormatter.formatNumberCellByRender(this.getBodyTable().getTable(), new int[]{7, 8});
         int[] toolTipColumns = new int[]{1, 2, 5, 6};

         for(int i = 0; i < toolTipColumns.length; ++i) {
            TableColumn column = this.getBodyTable().getTable().getColumnModel().getColumn(toolTipColumns[i]);
            column.setCellRenderer(this.tooltiprenderer);
         }
      }

      return this.bodyTable;
   }

   private UFDouble getCurAdjustedValue(CashflowForVoucherVO vo, UFDouble value, String pk_currtype, int direction) throws Exception {
      return direction == 0?(vo.getCreditAmount().doubleValue() != 0.0D?value.multiply(vo.getLocalCreditAmount()).div(vo.getCreditAmount()):(vo.getDebitAmount().doubleValue() != 0.0D?value.multiply(vo.getLocalDebitAmount()).div(vo.getDebitAmount()):new UFDouble(0))):(vo.getLocalCreditAmount().doubleValue() != 0.0D?value.multiply(vo.getCreditAmount()).div(vo.getLocalCreditAmount()):(vo.getLocalDebitAmount().doubleValue() != 0.0D?value.multiply(vo.getDebitAmount()).div(vo.getLocalDebitAmount()):new UFDouble(0)));
   }

   private UIButton getBtnAddLine() {
      if(this.btnAddLine == null) {
         this.btnAddLine = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC001-0000012"));
         this.btnAddLine.setDefaultSize();
      }

      return this.btnAddLine;
   }

   private UIButton getBtnAnalyze() {
      if(this.btnAnalyze == null) {
         this.btnAnalyze = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000368"));
         this.btnAnalyze.setDefaultSize();
      }

      return this.btnAnalyze;
   }

   private UIButton getBtnBatchOp() {
      if(this.btnBatchOp == null) {
         this.btnBatchOp = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000369"));
         this.btnBatchOp.setDefaultSize();
      }

      return this.btnBatchOp;
   }

   private UIButton getBtnDelLine() {
      if(this.btnDelLine == null) {
         this.btnDelLine = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC001-0000013"));
         this.btnDelLine.setDefaultSize();
      }

      return this.btnDelLine;
   }

   private UIButton getBtnLoad() {
      if(this.btnLoad == null) {
         this.btnLoad = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000370"));
         this.btnLoad.setDefaultSize();
      }

      return this.btnLoad;
   }

   private UIButton getBtnCancel() {
      if(this.btnCancel == null) {
         this.btnCancel = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC001-0000008"));
         this.btnCancel.setDefaultSize();
      }

      return this.btnCancel;
   }

   private UIButton getBtnOK() {
      if(this.btnOK == null) {
         this.btnOK = new UIButton(NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC001-0000044"));
         this.btnOK.setDefaultSize();
      }

      return this.btnOK;
   }

   private BillModel getBodyTableModel() {
      if(this.bodyTableModel == null) {
         Object[] names = new Object[]{NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0000548"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000061"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0003936"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0001755"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0002301"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000371"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000372"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0000901"), NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UC000-0002592"), "m_pk_detail", "m_pk_accsubj", "m_pk_currtype", "pk_cashflow_main", "pk_cashflow_ass", "assid", "m_pk_voucher", "debitAmount", "localDebitAmount", "creditAmount", "localCreditAmount", "fracCreditAmount", "fracDebitAmount", "fracAmount"};
         int[] dataTypes = new int[]{1, 0, 0, 6, 0, 5, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
         String[] keys = new String[]{"m_detailno", "m_subjname", "m_ass", "currtype", "m_dr", "mainCfItem", "subCFItem", "occAmount", "localAmount", "m_pk_detail", "m_pk_accsubj", "m_pk_currtype", "pk_cashflow_main", "pk_cashflow_ass", "assid", "m_pk_voucher", "debitAmount", "localDebitAmount", "creditAmount", "localCreditAmount", "fracCreditAmount", "fracDebitAmount", "fracAmount"};
         int[] widths = new int[]{30, 100, 100, 60, 50, 150, 140, 75, 75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
         BillItem[] billitems = new BillItem[names.length];

         for(int i = 0; i < names.length; ++i) {
            billitems[i] = new BillItem();
            billitems[i].setName(names[i].toString());
            billitems[i].setWidth(widths[i]);
            if(i != 3 && i <= 4 && (i != 0 || i >= 9)) {
               billitems[i].setEdit(false);
            } else {
               billitems[i].setEdit(true);
            }

            billitems[i].setDataType(dataTypes[i]);
            billitems[i].setKey(keys[i]);
            billitems[i].setShow(i <= 8);
         }

         billitems[3].setComponent(this.getCurrTypeBox());
         billitems[5].setComponent(this.getMainCfItemPane());
         billitems[6].setComponent(this.getSubCfItemPane());
         this.bodyTableModel = new BillModel();
         this.bodyTableModel.setBodyItems(billitems);
         this.getBodyTable().setTableModel(this.bodyTableModel);
      }

      return this.bodyTableModel;
   }

   public DetailVO[] getDetails() {
      return this.details;
   }

   public void setDetails(DetailVO[] details) {
      this.details = details;
   }

   public void setDispalyAlias() {
      String[] loadFormula_currtype = new String[]{"currtype->getColValue(bd_currtype,CURRTYPECODE,pk_currtype,m_pk_currtype)"};
      this.getBodyTable().getTableModel().getBodyItems()[3].setLoadFormula(loadFormula_currtype);
      this.getBodyTable().getTableModel().execLoadFormula();
   }

   public String getPK_GLOrgBook() {
      if(this.m_pk_glorgbook == null && ClientEnvironment.getInstance().getValue("pk_glorgbook") != null) {
         this.m_pk_glorgbook = ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).m_pk_glorgbook;
      }

      return this.m_pk_glorgbook;
   }

   public void setPk_glorgbook(String pk_glorgbook) {
      this.m_pk_glorgbook = pk_glorgbook;
      String pk_crop = BDGLOrgBookAccessor.getPk_corp(this.m_pk_glorgbook);
      this.getMainCfItemPane().getRef().getRefModel().setWherePart("  ( pk_corp =\'0001\' or pk_corp = \'" + this.getPK_Corp() + "\') and (itemflag is null or itemflag = \'0\') ");
      this.getMainCfItemPane().getRefModel().reloadData();
      this.getMainCfItemPane().setNotLeafSelectedEnabled(false);
      this.getSubCfItemPane().getRef().getRefModel().setWherePart("  ( pk_corp =\'0001\' or pk_corp = \'" + this.getPK_Corp() + "\') and itemflag = \'1\' ");
      this.getSubCfItemPane().getRefModel().reloadData();
      this.getSubCfItemPane().setNotLeafSelectedEnabled(false);
   }

   public String getPK_Corp() {
      if(this.m_pk_corp == null) {
         this.m_pk_corp = ClientEnvironment.getInstance().getCorporation().getPk_corp();
      }

      return this.m_pk_corp;
   }

   public void setPk_corp(String pk_corp) {
      this.m_pk_corp = pk_corp;
   }

   private CashflowForVoucherVO[] getCurrentBodyVOs() {
      CashflowForVoucherVO[] voucherVO = (CashflowForVoucherVO[])((CashflowForVoucherVO[])this.getBodyTable().getTableModel().getBodyValueVOs("nc.vo.gl.cashflowcase.CashflowForVoucherVO"));
      if(voucherVO != null && voucherVO.length > 0) {
         for(int i = 0; i < voucherVO.length; ++i) {
            DefaultConstEnum maincf = (DefaultConstEnum)this.getBodyTable().getTableModel().getValueAt(i, 5);
            this.getBodyTable().getTableModel().getValueAt(i, "subCFItem");
            DefaultConstEnum subcf = (DefaultConstEnum)this.getBodyTable().getTableModel().getValueAt(i, 6);
            if(maincf != null && voucherVO[i].getPk_cashflow_main() == null) {
               voucherVO[i].setPk_cashflow_main((String)maincf.getValue());
            }

            if(subcf != null && voucherVO[i].getPk_cashflow_ass() == null) {
               voucherVO[i].setPk_cashflow_ass((String)subcf.getValue());
            }
         }
      }

      return voucherVO;
   }

   private CashflowForVoucherVO formatVO(CashflowForVoucherVO vo) {
      String currtypePk = vo.getM_pk_currtype();
      vo.setOccAmount(this.getAmount(vo.getOccAmount(), this.getPK_GLOrgBook(), currtypePk));
      vo.setLocalAmount(this.getAmount(vo.getLocalAmount(), this.getPK_GLOrgBook(), this.getLocalCurrPk()));
      return vo;
   }

   public void formatLine(CashflowForVoucherVO vo, int row) {
      this.getBodyTable().getTableModel().setBodyRowVO(this.formatVO(vo), row);
      this.setDispalyAlias();
   }

   public void formatTable(CashflowForVoucherVO[] voucherVO) {
      CashflowForVoucherVO[] delegateVOs = voucherVO == null?this.getCurrentBodyVOs():voucherVO;
      if(delegateVOs != null && delegateVOs.length != 0) {
         CashflowForVoucherVO[] var3 = delegateVOs;
         int var4 = delegateVOs.length;

         for(int var5 = 0; var5 < var4; ++var5) {
            CashflowForVoucherVO vo = var3[var5];
            this.formatVO(vo);
         }

         this.getBodyTable().getTableModel().setBodyDataVO(delegateVOs);
         this.setDispalyAlias();
         this.getBodyTable().getTableModel().sortByColumn(0, true);
      }
   }

   private CashflowForVoucherVO getCurrentRowVO() {
      CashflowForVoucherVO vo = null;
      int row = this.getBodyTable().getTable().getSelectedRow();
      if(row != -1) {
         vo = (CashflowForVoucherVO)this.getBodyTable().getTableModel().getBodyValueRowVO(row, "nc.vo.gl.cashflowcase.CashflowForVoucherVO");
      }

      return vo;
   }

   private UFDouble getAmount(UFDouble value, String pk_glorgbook, String pk_currtype) {
      if(value == null) {
         return null;
      } else {
         String pk = null;
         if(pk_currtype == null) {
            pk = BDGLOrgBookAccessor.getGlBookVOByPk_glOrgBook(pk_glorgbook).m_pk_main_currtype;
         } else {
            pk = pk_currtype;
         }

         UFDouble dblnewValue = GlNumberFormat.formatUFDouble(value, VoucherDataCenter.getCurrtypeByPk_orgbook(pk_glorgbook, pk).getCurrdigit().intValue());
         return dblnewValue;
      }
   }

   public boolean beforeEdit(BillEditEvent e) {
      if(e.getKey().equals("occAmount")) {
         String pk_currtype = this.getCurrentRowVO().getM_pk_currtype();
         int pre = 2;

         try {
            if(pk_currtype != null) {
               pre = CurrencyDataCache.getInstance().getCurrtypeBypk(pk_currtype).getCurrdigit().intValue();
            }
         } catch (Exception var5) {
            MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), var5.getMessage());
         }

         ((UITextField)this.getMoneyEditor().getComponent()).setNumPoint(pre);
      }

      return true;
   }

   private UIRefPane getMainCfItemPane() {
      try {
         if(this.mainCfItemPane == null) {
            this.mainCfItemPane = new UIRefPane();
            this.mainCfItemPane.setRefNodeName("现金流量项目");
            this.mainCfItemPane.setName("mainCfItemPane");
            this.mainCfItemPane.addValueChangedListener(this);
         }
      } catch (Throwable var2) {
         Logger.error(var2);
      }

      return this.mainCfItemPane;
   }

   private UIRefPane getSubCfItemPane() {
      try {
         if(this.subCfItemPane == null) {
            this.subCfItemPane = new UIRefPane(this);
            this.subCfItemPane.setRefNodeName("现金流量项目");
            this.subCfItemPane.getRefModel().setPk_GlOrgBook("2", this.getPK_GLOrgBook());
            this.subCfItemPane.addValueChangedListener(this);
         }
      } catch (Throwable var2) {
         Logger.error(var2);
      }

      return this.subCfItemPane;
   }

   private UFDouble getVoucherCfAomount() {
      UFDouble temp1 = new UFDouble(0);
      boolean flag = false;

      for(int i = 0; i < this.details.length; ++i) {
         flag = false;
         AccsubjVO subj = AccsubjDataCache.getInstance().getAccsubjVOByPK(this.details[i].getPk_accsubj());
         this.subjmap.put(this.details[i].getPk_accsubj(), subj);
         if(subj != null && subj.getCashbankflag().intValue() > 0) {
            flag = true;
         }

         if(flag && flag) {
            if(this.details[i].getLocaldebitamount().doubleValue() != 0.0D) {
               temp1 = temp1.add(this.details[i].getLocaldebitamount());
            } else {
               temp1 = temp1.sub(this.details[i].getLocalcreditamount());
            }
         }
      }

      return temp1;
   }

   private String formatUFDouble(UFDouble amount) {
      DecimalFormat formatter = new DecimalFormat();
      int power = amount.getPower();
      String pattern = "#,###,###,###,##0.";

      for(int i = 0; i < -power; ++i) {
         pattern = pattern + "0";
      }

      pattern = pattern + ";-" + pattern;
      formatter.applyPattern(pattern);
      return formatter.format(amount);
   }

   public void setCfAmount() {
      String direction = this.getVoucherCfAomount().doubleValue() >= 0.0D?NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000373"):NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000374");
      UFDouble amount = this.getAmount(this.getVoucherCfAomount().abs(), this.getPK_GLOrgBook(), this.getLocalCurrPk());
      if(this.voucherVO.getVoucherkind().intValue() != 223) {
         String cfamount = this.getUILabelAmount().getText() + direction + this.formatUFDouble(amount);
         this.getUILabelAmount().setText(cfamount);
      }

   }

   private void adjustDirection(CashflowForVoucherVO vo) {
      try {
         CashflowVO e = CfVOAdapter.getCashflow(vo.getPk_cashflow_main());
         byte minus = -1;
         UFDouble amount = vo.getOccAmount();
         UFDouble localAmount = vo.getLocalAmount();
         String pkcurrtype = vo.getM_pk_currtype();
         UFDouble nativeAmount = null;
         UFDouble nativeLocalAmount = null;
         if(this.details[vo.getM_detailno().intValue() - 1].getCreditamount() != null && this.details[vo.getM_detailno().intValue() - 1].getCreditamount().doubleValue() != 0.0D) {
            nativeAmount = this.details[vo.getM_detailno().intValue() - 1].getCreditamount();
         } else {
            nativeAmount = this.details[vo.getM_detailno().intValue() - 1].getDebitamount();
         }

         if(this.details[vo.getM_detailno().intValue() - 1].getLocalcreditamount() != null && this.details[vo.getM_detailno().intValue() - 1].getLocalcreditamount().doubleValue() != 0.0D) {
            nativeLocalAmount = this.details[vo.getM_detailno().intValue() - 1].getLocalcreditamount();
         } else {
            nativeLocalAmount = this.details[vo.getM_detailno().intValue() - 1].getLocaldebitamount();
         }

         if((e.getCftype().intValue() == 1 && vo.getM_dr().equals(OrientConst.DEBIT) || e.getCftype().intValue() == 2 && vo.getM_dr().equals(OrientConst.CREDIT)) && (nativeAmount.doubleValue() > 0.0D && amount.doubleValue() > 0.0D || nativeAmount.doubleValue() < 0.0D && amount.doubleValue() < 0.0D)) {
            amount = amount.multiply((double)minus);
            localAmount = localAmount.multiply((double)minus);
         }

         if((e.getCftype().intValue() == 1 && vo.getM_dr().equals(OrientConst.CREDIT) || e.getCftype().intValue() == 2 && vo.getM_dr().equals(OrientConst.DEBIT)) && (nativeAmount.doubleValue() > 0.0D && amount.doubleValue() < 0.0D || nativeAmount.doubleValue() < 0.0D && amount.doubleValue() > 0.0D)) {
            amount = amount.multiply((double)minus);
            localAmount = localAmount.multiply((double)minus);
         }

         boolean isCfSubj = false;
         AccsubjVO subj = (AccsubjVO)this.subjmap.get(this.details[vo.getM_detailno().intValue() - 1].getPk_accsubj());
         if(subj != null && subj.getCashbankflag().intValue() > 0) {
            isCfSubj = true;
         }

         if(isCfSubj) {
            amount = amount.multiply(-1.0D);
            localAmount = localAmount.multiply(-1.0D);
         }

         if(e.getItemflag() == null || e.getItemflag().equals("0") && amount.compareTo(new UFDouble("0")) == 0) {
            String dir = "借";
            if(e.getCftype().intValue() == 1) {
               dir = "贷";
            }

            if((e.getCftype().intValue() == 1 && vo.getM_dr().equals(OrientConst.DEBIT) || e.getCftype().intValue() == 2 && vo.getM_dr().equals(OrientConst.CREDIT)) && (nativeLocalAmount.doubleValue() > 0.0D && localAmount.doubleValue() > 0.0D || nativeLocalAmount.doubleValue() < 0.0D && localAmount.doubleValue() < 0.0D)) {
               amount = amount.multiply((double)minus);
               localAmount = localAmount.multiply((double)minus);
            }

            if((e.getCftype().intValue() == 1 && vo.getM_dr().equals(OrientConst.CREDIT) || e.getCftype().intValue() == 2 && vo.getM_dr().equals(OrientConst.DEBIT)) && (nativeLocalAmount.doubleValue() > 0.0D && localAmount.doubleValue() < 0.0D || nativeLocalAmount.doubleValue() < 0.0D && localAmount.doubleValue() > 0.0D)) {
               amount = amount.multiply((double)minus);
               localAmount = localAmount.multiply((double)minus);
            }
         }

         vo.setOccAmount(this.getAmount(amount, this.getPK_GLOrgBook(), pkcurrtype));
         vo.setLocalAmount(this.getAmount(localAmount, this.getPK_GLOrgBook(), pkcurrtype));
      } catch (Exception var12) {
         Logger.error(var12);
         var12.printStackTrace();
      }

   }

   public void selectionChanged(BillTableSelectionEvent e) {
      if(this.getBodyTable().getTable() != null) {
         this.currentselectedrow = e.getSelectIndex();
         int row = this.currentselectedrow;
         CashflowForVoucherVO[] vos = this.getCurrentBodyVOs();
         if(row != -1 && vos.length > 0) {
            if(vos[row].getPk_cashflow_main() != null) {
               this.getMainCfItemPane().setPK(vos[row].getPk_cashflow_main());
            }

            if(vos[row].getPk_cashflow_ass() != null) {
               this.getSubCfItemPane().setPK(vos[row].getPk_cashflow_ass());
            }
         }
      }

   }

   private String getCfItemFlagByPk(String pk_corp, String pk) {
      nc.vo.bd.b60.CashflowVO cfvo = CashFlowDataCache.getInstance().getCashflowVOByPkcorpandPk(pk_corp, pk);
      if(cfvo == null) {
         cfvo = CashFlowDataCache.getInstance().getCashflowVOByPkcorpandPk("0001", pk);
         return cfvo == null?null:cfvo.getItemflag();
      } else {
         return cfvo.getItemflag();
      }
   }

   public UFDate getDate() {
      return this.date;
   }

   public void setDate(UFDate date) {
      this.date = date;
   }

   public int getEditMode() {
      return this.editMode;
   }

   public void setEditMode(int editMode) {
      this.editMode = editMode;
   }

   public CashflowVO[] getCashflows() throws Exception {
      if(this.cashflows == null) {
         CashflowVO qryVO = new CashflowVO();
         qryVO.setPk_corp(this.getPK_Corp());
         qryVO.setPk_glorgbook(this.getPK_GLOrgBook());
         this.cashflows = CFPubProxy.getRemoteCashFlowCase().queryCashflow(qryVO, Boolean.TRUE);
      }

      return this.cashflows;
   }

   public SubrelationVO[] getSubRelation() throws Exception {
      if(this.subRelation == null) {
         this.subRelation = CFPubProxy.getRemoteCashFlowCase().querySubrelationBySubjSpread(this.getPK_GLOrgBook());
         this.getSortTool().SortVos(this.subRelation);
      }

      return this.subRelation;
   }

   private void analyzeVoucher() throws Exception {
      (new CashflowAnalyzeExecutor(this, this, true)).execute();
   }

   public CfAnalyzeEnvVO getCfAnalyzeEnvVO() {
      nc.vo.gl.cashflowcase.VoucherVO[] vos = null;

      try {
         vos = CfVOAdapter.transferToVoucherVO(this.getDetails(), this.subjmap);
         if(vos != null && vos.length != 0) {
            if(this.selectedIndex == null) {
               this.selectedIndex = Integer.valueOf(0);
            }

            if(vos.length >= this.selectedIndex.intValue() + 1) {
               vos[this.selectedIndex.intValue()].setMainsub(true);
            }

            if(vos != null && vos.length != 0) {
               CfAnalyzeEnvVO e = new CfAnalyzeEnvVO();
               e.setAnalyzeType(this.getAnalyzeType().getSelectedItem().toString());
               e.setPk_corp(this.getPK_Corp());
               e.setM_pk_glorgbook(this.getPK_GLOrgBook());
               e.setVos(vos);
               e.setCashflows(this.getCashflows());
               e.fillSubRelation(this.getSubRelation());
               e.setSubflag(true);
               e.setContainer(this);
               return e;
            } else {
               return null;
            }
         } else {
            return null;
         }
      } catch (Exception var3) {
         Logger.error(var3);
         MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000344"), var3.getMessage());
         return null;
      }
   }

   public CashFlowSortTool getSortTool() {
      if(this.sortTool == null) {
         this.sortTool = new CashFlowSortTool();
      }

      return this.sortTool;
   }

   public Integer getSelectedIndex() {
      return this.selectedIndex;
   }

   public void setSelectedIndex(Integer selectedIndex) {
      this.selectedIndex = selectedIndex;
   }

   public void setUnanalyzedDetails(Vector unanalyzedDetails) {
      this.unanalyzedDetails = unanalyzedDetails;
   }

   public void setAnalyzedDetails(Vector analyzedDetails) {
      this.analyzedDetails = analyzedDetails;
      if(analyzedDetails != null) {
         this.getBodyTable().getTableModel().setBodyDataVO((CircularlyAccessibleValueObject[])analyzedDetails.toArray(new CashflowForVoucherVO[0]));
      }

   }

   public void afterAnalyze(Vector analyzeResults) {
      CashflowcaseVO[] casevos = analyzeResults == null?null:(CashflowcaseVO[])analyzeResults.toArray(new CashflowcaseVO[0]);
      if(casevos != null && casevos.length != 0) {
         CashflowForVoucherVO[] result = null;

         try {
            result = CfVOAdapter.refreshCfVOByCaseVO((CashflowForVoucherVO[])this.getUnCfDetail().toArray(new CashflowForVoucherVO[0]), casevos);
            this.formatTable(result);
         } catch (Exception var5) {
            Logger.error(var5);
         }

      } else {
         this.setAnalyzedDetails(this.analyzedDetails);
      }
   }

   public boolean beforeAnalyze() {
      return true;
   }

   public VoucherVO getVoucherVO() {
      return this.voucherVO;
   }

   public void setVoucherVO(VoucherVO voucherVO) {
      this.voucherVO = voucherVO;
   }

   class IvjEventHandler implements ActionListener {

      public void actionPerformed(ActionEvent e) {
         if(e.getSource() == CFAnalyzeJitUI.this.getBtnCancel()) {
            CFAnalyzeJitUI.this.connEtoC1();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnOK()) {
            CFAnalyzeJitUI.this.connEtoC2();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnLoad()) {
            CFAnalyzeJitUI.this.connEtoC3();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnAnalyze()) {
            CFAnalyzeJitUI.this.connEtoC4();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnBatchOp()) {
            CFAnalyzeJitUI.this.connEtoC5();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnAddLine()) {
            CFAnalyzeJitUI.this.connEtoC7();
         }

         if(e.getSource() == CFAnalyzeJitUI.this.getBtnDelLine()) {
            CFAnalyzeJitUI.this.connEtoC6();
         }

      }
   }

   static class ToolTipRenderer extends UILabel implements TableCellRenderer {

      private static final long serialVersionUID = 1L;
      private static final Border noFocusBorder = new EmptyBorder(1, 2, 1, 2);
      private Color unselectedForeground;
      private Color unselectedBackground;


      public ToolTipRenderer() {
         this.setILabelType(0);
         this.setOpaque(true);
         this.setBorder(noFocusBorder);
      }

      public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
         if(isSelected) {
            super.setForeground(table.getSelectionForeground());
            super.setBackground(table.getSelectionBackground());
         } else {
            super.setForeground(this.unselectedForeground != null?this.unselectedForeground:table.getForeground());
            super.setBackground(this.unselectedBackground != null?this.unselectedBackground:table.getBackground());
         }

         if(hasFocus) {
            this.setBorder(UIManager.getBorder("Table.focusCellHighlightBorder"));
            if(table.isCellEditable(row, column)) {
               super.setForeground(UIManager.getColor("Table.focusCellForeground"));
               super.setBackground(UIManager.getColor("Table.focusCellBackground"));
            }
         } else {
            this.setBorder(noFocusBorder);
         }

         this.setText(value == null?"":value.toString());
         return this;
      }

   }
}
